﻿Imports System
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.Linq.Expressions

Namespace Core.Repositories

    Public Interface IRepository(Of TEntity As Class)

        Enum LoadTypes
            GetActiveOnly
            GetDeletedOnly
            GetAll
        End Enum

        Function [Get](ByVal id As Guid) As TEntity

        Function GetAll(Optional IncludeDeleted As Boolean = False) As IQueryable(Of TEntity)

        Function Find(ByVal predicate As Expression(Of Func(Of TEntity, Boolean))) As IEnumerable(Of TEntity)

        Function SingleOrDefault(ByVal predicate As Expression(Of Func(Of TEntity, Boolean))) As TEntity

        Sub Add(ByVal entity As TEntity)

        Sub AddRange(ByVal entities As IEnumerable(Of TEntity))

        Sub Remove(ByVal entity As TEntity)

        Sub RemoveRange(ByVal entities As IEnumerable(Of TEntity))

    End Interface
End Namespace