﻿Imports UoWTestApp.Core
Imports UoWTestApp.Core.Repositories
Imports UoWTestApp.Persistence.Repositories

Namespace Persistence
    Public Class UnitOfWork
        Implements IUnitOfWork

        ReadOnly Property _context As UoWTestAppModel

        Sub New(ByVal context As UoWTestAppModel)
            _context = context
            Currencies = New CurrenciesRepository(_context)
        End Sub

#Region "Accounting"
        Public Property Currencies As ICurrenciesRepository Implements IUnitOfWork.Currency
#End Region


        Public Function Complete(Optional vRealDelete As Boolean = False) As Integer Implements IUnitOfWork.Complete
            If vRealDelete Then
                Return _context.SaveChangesRealDelete
            Else
                Return _context.SaveChanges
            End If
        End Function

#Region "IDisposable Support"
        Public Sub Dispose() Implements IDisposable.Dispose
            _context.Dispose()
        End Sub
#End Region
    End Class
End Namespace
