Imports System
Imports System.Data.Entity
Imports System.Linq
Imports UoWTestApp.Interfaces

Public Class UoWTestAppModel
    Inherits DbContext

    ' Your context has been configured to use a 'UoWTestAppModel' connection string from your application's 
    ' configuration file (App.config or Web.config). By default, this connection string targets the 
    ' 'UoWTestApp.UoWTestAppModel' database on your LocalDb instance. 
    ' 
    ' If you wish to target a different database and/or database provider, modify the 'UoWTestAppModel' 
    ' connection string in the application configuration file.
    Public Sub New()
        MyBase.New("name=UoWTestAppModel")
    End Sub

    'Override for the SaveChanged Sub to deal with created and edit Interfaces
    Public Overrides Function SaveChanges() As Integer
        Dim objectStateEntries = ChangeTracker.Entries().Where(Function(e) TypeOf e.Entity Is model_base AndAlso e.State <> EntityState.Detached AndAlso e.State <> EntityState.Unchanged).ToList()
        For Each _Entry In objectStateEntries
            Dim entityBase = TryCast(_Entry.Entity, model_base)
            If entityBase Is Nothing Then Continue For
            Select Case _Entry.State
                Case EntityState.Deleted
                    Dim logicalDelete = TryCast(entityBase, IDelete)
                    If (logicalDelete IsNot Nothing) Then
                        _Entry.State = EntityState.Modified
                        logicalDelete.DeletedTimeStamp = DateTime.Now
                        logicalDelete.Deleted = True
                    End If
            End Select
        Next
        Return MyBase.SaveChanges()
    End Function

    Public Function SaveChangesRealDelete() As Integer
        Return MyBase.SaveChanges
    End Function

    Public Overridable Property Currencies As DbSet(Of Currency)


    Protected Overrides Sub OnModelCreating(ByVal modelBuilder As DbModelBuilder)

    End Sub

End Class